/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.TipoServicio;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoServicio;
import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaTipoServicioController")
@Scope("prototype")
public class BusquedaTipoServicioController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoServicio> plwTipoServicio;
    private MyListbox tipoServicioList;
    private Paging pagingTipoServicio;
    private Textbox txtNombre;

    public Paging getPagingTipoServicio() {
        return pagingTipoServicio;
    }

    public void setPagingTipoServicio(Paging pagingTipoServicio) {
        this.pagingTipoServicio = pagingTipoServicio;
    }

    public MyListbox getTipoServicioList() {
        return tipoServicioList;
    }

    public void setTipoServicioList(MyListbox tipoServicioList) {
        this.tipoServicioList = tipoServicioList;
    }

    public PagedListWrapper<TipoServicio> getPlwTipoServicio() {
        return plwTipoServicio;
    }

    public void setPlwTipoServicio(PagedListWrapper<TipoServicio> plwTipoServicio) {
        this.plwTipoServicio = plwTipoServicio;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new TipoServicio());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoServicioList.setItemRenderer(new RenderTipoServicio());
        tipoServicioList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoServicio ts = (TipoServicio) tipoServicioList.getSelected();
                verPeriodo(ts);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verPeriodo(TipoServicio ts) {
        if (ts == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tipoServicio", ts);
        args.put("tipoServicioList", tipoServicioList);

        openWindow("/gui/catalogos/editarTipoServicio.zul",
                Labels.getLabel("editarTipoServicioController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TipoServicio> claseServicioBusqueda =new HibernateSearchObject<TipoServicio>(TipoServicio.class, pagingTipoServicio.getPageSize());

        //claseServicioBusqueda.addFilterLike("descservicio", "%" + txtNombre.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
        claseServicioBusqueda.addSortAsc("descservicio");
        claseServicioBusqueda.addFilterNotEqual("tiposervicioId", -1);

        plwTipoServicio.init(claseServicioBusqueda, tipoServicioList, pagingTipoServicio);

        if (tipoServicioList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTipoServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
